﻿//********************************** Banshee Engine (www.banshee3d.com) **************************************************//
//**************** Copyright (c) 2016 Marko Pintera (marko.pintera@gmail.com). All rights reserved. **********************//
using System.Runtime.CompilerServices;

[assembly: InternalsVisibleTo("MBansheeEditor")]

namespace BansheeEngine
{
    /** @addtogroup BansheeEngine
     *  Primary scripting API.
     *  @{
     */

    /** @defgroup GUI-Engine GUI 
     *  Graphical user interface, including elements, styles and localization.
     */

    /** @defgroup Input Input 
     *  %Input (mouse, keyboard, gamepad, etc.).
     */

    /** @defgroup Math Math 
     *  Variety of general purpose math functionality.
     */

    /** @defgroup Physics Physics 
     *  %Physics system: colliders, triggers, rigidbodies, joints, scene queries, etc.
     */

    /** @cond INTEROP */
    /** @defgroup Interop Interop 
     *  Glue types that are used for C++/C# interop.
     */
    /** @endcond */

    /** @defgroup Rendering Rendering 
     *  Materials, shaders, textures, meshes and components relating to rendering.
     */

    /** @defgroup Resources Resources 
     *  Resource types and resource management functionality.
     */

    /** @defgroup Scene Scene 
     *  Scene objects and components.
     */

    /** @defgroup Serialization Serialization 
     *  Serialization and deserialization of native objects.
     */

    /** @defgroup Utility Utility 
     *  Various utility functionality.
     */

    /** @} */

    /** @cond INTEROP */

    /// <summary>
    /// Contains the primary entry point for the program.
    /// </summary>
    class Program
    {
        /// <summary>
        /// Assembly entry point. Unused.
        /// </summary>
        static void Start()
        {

        }
    }

    /** @endcond */
}
